/*
 * Copyright (C) 2012-2014  Roman Pauer
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

#ifndef __SCALERS_H__
#define __SCALERS_H__

#include <stdint.h>


void _eagle2x_16_16(const uint16_t * restrict src, uint16_t * restrict dst, int width, int srcstride, int dststride, int height);

void _scale2x_16_16(const uint16_t * restrict src, uint16_t * restrict dst, int width, int srcstride, int dststride, int height);
void _scale2x_16_16_srcdma(const uint16_t * restrict src, uint16_t * restrict dst, int width, int srcstride, int dststride, int height);
void _scale2x_16_16_dstdma(const uint16_t * restrict src, uint16_t * restrict dst, int width, int srcstride, int dststride, int height);
void _scale2x_16_16_dma(const uint16_t * restrict src, uint16_t * restrict dst, int width, int srcstride, int dststride, int height);
void _scale2x_16_16_dmalink(const uint16_t * restrict src, uint16_t * restrict dst, int width, int srcstride, int dststride, int height);

void _scale2x_8_16(const uint8_t * restrict src, uint16_t * restrict dst, const uint16_t * restrict pal, int width, int srcstride, int dststride, int height);
void _scale2x_8_16_srcdma(const uint8_t * restrict src, uint16_t * restrict dst, const uint16_t * restrict pal, int width, int srcstride, int dststride, int height);
void _scale2x_8_16_dstdma(const uint8_t * restrict src, uint16_t * restrict dst, const uint16_t * restrict pal, int width, int srcstride, int dststride, int height);
void _scale2x_8_16_dma(const uint8_t * restrict src, uint16_t * restrict dst, const uint16_t * restrict pal, int width, int srcstride, int dststride, int height);
void _scale2x_8_16_dmalink(const uint8_t * restrict src, uint16_t * restrict dst, const uint16_t * restrict pal, int width, int srcstride, int dststride, int height);

void __2xsai_16_16(const uint16_t * restrict src, uint16_t * restrict dst, int width, int srcstride, int dststride, int height);
void __2xsai_16_16_srcdma(const uint16_t * restrict src, uint16_t * restrict dst, int width, int srcstride, int dststride, int height);
void __2xsai_16_16_dstdma(const uint16_t * restrict src, uint16_t * restrict dst, int width, int srcstride, int dststride, int height);
void __2xsai_16_16_dma(const uint16_t * restrict src, uint16_t * restrict dst, int width, int srcstride, int dststride, int height);
void __2xsai_16_16_dmalink(const uint16_t * restrict src, uint16_t * restrict dst, int width, int srcstride, int dststride, int height);

#endif /* __SCALERS_H__ */

